%define _hardened_build 1
%define privoxyconf %{_sysconfdir}/%{name}
%define privoxy_uid 73
%define privoxy_gid 73
%define beta_or_stable stable

Name: privoxy
Version: 3.0.34
Release:    1%{?dist}
Summary: Privacy enhancing proxy
License: GPL-2.0-or-later
Source0: http://downloads.sourceforge.net/ijbswa/%{name}-%{version}-%{beta_or_stable}-src.tar.gz
Source1: privoxy.service
Source2: privoxy.logrotate
Patch0: 53748ca8ca3c893025be34dd4f104546fcbd0602.patch
Patch1: e73b93ea9ad1f3e980bd78ed3ebf65dedbb598a2.patch
Patch2: 87253c999d5628a6e9287bb0cc613d7b44bcec09.patch
Patch3: privoxy-configure-c99.patch
Patch4: 19d7684ca10f6c1279568aa19e9a9da2276851f1.patch
URL: http://www.privoxy.org/
Requires(pre): shadow-utils
BuildRequires: make
BuildRequires: libtool autoconf pcre2-devel zlib-devel systemd

%description 
Privoxy is a web proxy with advanced filtering capabilities for
protecting privacy, filtering web page content, managing cookies,
controlling access, and removing ads, banners, pop-ups and other
obnoxious Internet junk. Privoxy has a very flexible configuration and
can be customized to suit individual needs and tastes. Privoxy has application
for both stand-alone systems and multi-user networks.

Privoxy is based on the Internet Junkbuster.

%prep
%setup -q -n %{name}-%{version}-%{beta_or_stable}

%patch -P 0 -p 1
%patch -P 1 -p 1
%patch -P 2 -p 1
%patch -P 3 -p 1
%patch -P 4 -p 1

%build
rm -rf autom4te.cache
autoreconf
%configure
make %{?_smp_mflags}


%install
mkdir -p %{buildroot}%{_sbindir} \
         %{buildroot}%{_mandir}/man8 \
         %{buildroot}%{_localstatedir}/log/%{name} \
         %{buildroot}%{privoxyconf}/templates \
         %{buildroot}%{_unitdir}

install -p -m 755 %{name} %{buildroot}%{_sbindir}/%{name}
install -p -m 644 {config,*.action,default.filter,trust} %{buildroot}%{privoxyconf}/
install -p -m 644 templates/* %{buildroot}%{privoxyconf}/templates
install -p -m 644 %{name}.8 %{buildroot}%{_mandir}/man8/%{name}.8
install -p -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
install -p -m 711 -d %{buildroot}%{_localstatedir}/log/%{name}

sed -i -e 's@^confdir.*@confdir %{privoxyconf}@g' %{buildroot}%{privoxyconf}/config
sed -i -e 's@^logdir.*@logdir %{_localstatedir}/log/%{name}@g' %{buildroot}%{privoxyconf}/config

touch %{buildroot}%{_sysconfdir}/privoxy/user.filter

mkdir -p %{buildroot}/%{_sysconfdir}/logrotate.d
cp -p %{SOURCE2} %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}


%pre
if [ $1 -eq "1" ]; then
    %{_sbindir}/groupadd -g %{privoxy_gid} %{name} > /dev/null 2>&1 ||:
    %{_sbindir}/useradd -u %{privoxy_uid} -g %{privoxy_gid} -d %{privoxyconf} -r -s "/sbin/nologin" %{name} > /dev/null 2>&1 ||:
fi


%post
%systemd_post privoxy.service

if [[ ! -f %{_sysconfdir}/privoxy/user.filter ]]
then
    touch %{_sysconfdir}/privoxy/user.filter
fi

%preun
%systemd_preun privoxy.service

%postun
%systemd_postun_with_restart privoxy.service


%files
%defattr(-,%{name},%{name},-)
%dir %{_localstatedir}/log/%{name}

%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/privoxy/user.filter
%attr(0755,root,root)%{_sbindir}/%{name}
%config(noreplace) %{privoxyconf}
%attr(0644,root,root) %{_unitdir}/%{name}.service
%{_mandir}/man8/%{name}.*
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%doc README AUTHORS ChangeLog LICENSE 
%doc doc

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.34-1
- initial build
